/*
 * Copyright 2006-2009, Thomas Maier-Komor
 * LICENSE: GPLv3, see file COPYING for details
 */

#ifndef FSSTATS_H
#define FSSTATS_H

#include <stddef.h>
#include <sys/time.h>

#ifndef __sun
typedef uint64_t hrtime_t;
#endif

typedef struct fsstat_s {
	uint64_t free, blocks;
	unsigned long fsid;
	hrtime_t ts, rate_ts;
	double read_rate, write_rate, ops_rate;
	char *dev, *mnt;
	char typ[8];
	uint64_t
		naccess, naddmap, nclose, ncmp, ncreate, ndelmap,
		ndispose, ndump, ndumpctl, nfid, nfrlock, nfsync,
		ngetattr, ngetpage, ngetsecattr, ninactive, nioctl,
		nlink, nlookup, nmap, nmkdir, nopen, npageio, npathconf,
		npoll, nputpage, nread, nreaddir, nreadlink, nrealvp,
		nremove, nrename, nrmdir, nrwlock, nrwunlock, nseek,
		nsetattr, nsetfl, nsetsecattr, nshrlock, nspace,
		nsymlink, nvnevent, nwrite,
		ntotal, numread, numreaddir, numwrite, numzfs;
	struct fsstat_s *zroot, *next;
} fsstat_t;

extern uint64_t FsFree, FsSize, Zsize, Zfree;
extern unsigned long Zpools;
extern unsigned NumFs;

extern fsstat_t *get_fs_stats(void);
extern int update_fs_stats(void);
extern void init_zfs(void);

#endif
