/*
 * Copyright 2006-2009, Thomas Maier-Komor
 * LICENSE: GPLv3, see file COPYING for details
 */

#ifndef USERSTAT_H
#define USERSTAT_H

#include <time.h>
#include <sys/types.h>

typedef struct userstat_s {
	unsigned long nproc, nlwp, rss, size, h_s;
	unsigned long oncpu, sleeping, runnable, zombie, stopped;
	struct { long tv_sec, tv_nsec; } time;
	uint16_t pctcpu, pctmem;
	uid_t uid;
	char *username;
	struct userstat_s *next;
} userstat_t;

extern userstat_t *get_procinfo(void);
extern void set_sort_by_pcpu(void);
extern void set_sort_by_nproc(void);
extern void set_sort_by_rss(void);
extern void set_sort_by_hs(void);
extern void set_sort_by_size(void);
extern void set_sort_by_time(void);
extern void set_sort_by_user(void);
extern userstat_t *sort_users(userstat_t *);
extern void init_userstat(void);
extern void *Libc;

#endif
